pcl::FastBilateralFilterOMP< PointT > Class Template Reference

Implementation of a fast bilateral filter for smoothing depth information in organized point clouds Based on the following paper: More...

`#include <pcl/filters/fast_bilateral_omp.h>`

Inheritance diagram for pcl::FastBilateralFilterOMP< PointT >:

## Public Types

typedef boost::shared_ptr< FastBilateralFilterOMP< PointT > > | Ptr
typedef boost::shared_ptr< const FastBilateralFilterOMP< PointT > > | ConstPtr
Public Types inherited from pcl::FastBilateralFilter< PointT >
typedef boost::shared_ptr< FastBilateralFilter< PointT > > | Ptr
typedef boost::shared_ptr< const FastBilateralFilter< PointT > > | ConstPtr
Public Types inherited from pcl::Filter< PointT >
typedef boost::shared_ptr< Filter< PointT > > | Ptr
typedef boost::shared_ptr< const Filter< PointT > > | ConstPtr
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
Public Types inherited from pcl::PCLBase< PointT >
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| FastBilateralFilterOMP (unsigned int nr_threads=0)
| Empty constructor. More...
void | setNumberOfThreads (unsigned int nr_threads=0)
| Initialize the scheduler and set the number of threads to use. More...
void | applyFilter (PointCloud &output)
| Filter the input data and store the results into output. More...
Public Member Functions inherited from pcl::FastBilateralFilter< PointT >
| FastBilateralFilter ()
| Empty constructor. More...
virtual | ~FastBilateralFilter ()
| Empty destructor. More...
void | setSigmaS (float sigma_s)
| Set the standard deviation of the Gaussian used by the bilateral filter for the spatial neighborhood/window. More...
float | getSigmaS () const
| Get the size of the Gaussian bilateral filter window as set by the user. More...
void | setSigmaR (float sigma_r)
| Set the standard deviation of the Gaussian used to control how much an adjacent pixel is downweighted because of the intensity difference (depth in our case). More...
float | getSigmaR () const
| Get the standard deviation of the Gaussian for the intensity difference. More...
Public Member Functions inherited from pcl::Filter< PointT >
| Filter (bool extract_removed_indices=false)
| Empty constructor. More...
virtual | ~Filter ()
| Empty destructor. More...
IndicesConstPtr const | getRemovedIndices ()
| Get the point indices being removed. More...
void | getRemovedIndices (PointIndices &pi)
| Get the point indices being removed. More...
void | filter (PointCloud &output)
| Calls the filtering method and returns the filtered dataset in output. More...
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Types

typedef FastBilateralFilter< PointT >::Array3D | Array3D
typedef Filter< PointT >::PointCloud | PointCloud
Protected Types inherited from pcl::FastBilateralFilter< PointT >
typedef Filter< PointT >::PointCloud | PointCloud

## Protected Attributes

unsigned int | threads_
| The number of threads the scheduler should use. More...
Protected Attributes inherited from pcl::FastBilateralFilter< PointT >
float | sigma_s_
float | sigma_r_
bool | early_division_
Protected Attributes inherited from pcl::Filter< PointT >
IndicesPtr | removed_indices_
| Indices of the points that are removed. More...
std::string | filter_name_
| The filter name. More...
bool | extract_removed_indices_
| Set to true if we want to return the indices of the removed points. More...
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Additional Inherited Members

Protected Member Functions inherited from pcl::Filter< PointT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Detailed Description

### template<typename PointT>
class pcl::FastBilateralFilterOMP< PointT >

Implementation of a fast bilateral filter for smoothing depth information in organized point clouds Based on the following paper:

- Sylvain Paris and Frdo Durand "A Fast Approximation of the Bilateral Filter using a Signal Processing Approach" European Conference on Computer Vision (ECCV'06)

More details on the webpage: http://people.csail.mit.edu/sparis/bf/

Definition at line 59 of file fast_bilateral_omp.h.

## Member Typedef Documentation

template<typename PointT >

typedef FastBilateralFilter<PointT>::Array3D pcl::FastBilateralFilterOMP< PointT >::Array3D

protected

Definition at line 66 of file fast_bilateral_omp.h.

template<typename PointT >

typedef boost::shared_ptr< const FastBilateralFilterOMP<PointT> > pcl::FastBilateralFilterOMP< PointT >::ConstPtr

Definition at line 73 of file fast_bilateral_omp.h.

template<typename PointT >

typedef Filter<PointT>::PointCloud pcl::FastBilateralFilterOMP< PointT >::PointCloud

protected

Definition at line 68 of file fast_bilateral_omp.h.

template<typename PointT >

typedef boost::shared_ptr< FastBilateralFilterOMP<PointT> > pcl::FastBilateralFilterOMP< PointT >::Ptr

Definition at line 72 of file fast_bilateral_omp.h.

## Constructor & Destructor Documentation

template<typename PointT >

pcl::FastBilateralFilterOMP< PointT >::FastBilateralFilterOMP | ( | unsigned int | nr_threads = `0` | ) |

inline

Empty constructor.

Definition at line 76 of file fast_bilateral_omp.h.

## Member Function Documentation

template<typename PointT >

void pcl::FastBilateralFilterOMP< PointT >::applyFilter | ( | PointCloud & | output | ) |

virtual

Filter the input data and store the results into output.

Parameters

  [out] | output | the resultant point cloud

Reimplemented from pcl::FastBilateralFilter< PointT >.

Definition at line 50 of file fast_bilateral_omp.hpp.

References pcl::PointCloud< PointT >::at(), pcl::FastBilateralFilter< PointT >::Array3D::begin(), pcl::copyPointCloud(), pcl::FastBilateralFilter< PointT >::Array3D::end(), pcl::PointCloud< PointT >::height, pcl::PointCloud< PointT >::size(), pcl::FastBilateralFilter< PointT >::Array3D::trilinear_interpolation(), and pcl::PointCloud< PointT >::width.

Referenced by pcl::FastBilateralFilterOMP< PointT >::setNumberOfThreads().

template<typename PointT >

void pcl::FastBilateralFilterOMP< PointT >::setNumberOfThreads | ( | unsigned int | nr_threads = `0` | ) |

inline

Initialize the scheduler and set the number of threads to use.

Parameters

  nr_threads | the number of hardware threads to use (0 sets the value back to automatic)

Definition at line 84 of file fast_bilateral_omp.h.

References pcl::FastBilateralFilterOMP< PointT >::applyFilter(), and pcl::FastBilateralFilterOMP< PointT >::threads_.

## Member Data Documentation

template<typename PointT >

unsigned int pcl::FastBilateralFilterOMP< PointT >::threads_

protected

The number of threads the scheduler should use.

Definition at line 94 of file fast_bilateral_omp.h.

Referenced by pcl::FastBilateralFilterOMP< PointT >::setNumberOfThreads().

The documentation for this class was generated from the following files:

- /build/pcl-0nnAvv/pcl-1.7.2/filters/include/pcl/filters/fast_bilateral_omp.h
- /build/pcl-0nnAvv/pcl-1.7.2/filters/include/pcl/filters/impl/fast_bilateral_omp.hpp